( function( $ ) {

	$.fn.appleServicesTokenGenerator = function() {
		return this.each( function() {
			const $this            = $( this )
			    , generatorUrl     = $this.data( "generatorUrl" )
			    , service          = $this.data( "service" )
			    , alertPosition    = $this.data( "alertPosition" )
			    , alertTitle       = $this.data( "alertTitle" )
			    , copiedText       = $this.data( "copiedText" )
			    , $expiryField     = $( ".token-generator-expiry"     , $this )
			    , $expiryUnitField = $( ".token-generator-expiry-unit", $this )
			    , $generateButton  = $( ".token-generator-button"     , $this )
			    , $outputDiv       = $( ".token-generator-output"     , $this )
			    , $outputField     = $( "textarea", $outputDiv );


			// ======================
			// Set up listeners
			// ======================

			$generateButton.on( "click", generate );
			$outputField.on( "click", selectAndCopy );


			// ======================
			// Define functions
			// ======================

			function generate() {
				$.ajax( {
					  url  : generatorUrl
					, data : {
						  service : service
						, expiry  : $expiryField.val()
						, unit    : $expiryUnitField.val()
					}
				} ).done( function( data ) {
					$outputField.val( data.token );
					$outputDiv.show();
				} ).fail( function( jqXHR, textStatus, errorThrown ) {
					$.gritter.options.position = alertPosition;
					$.gritter.add( {
						  title      : alertTitle
						, text       : errorThrown
						, class_name : "gritter-error"
						, sticky     : false
					} );
				} );
			}

			function selectAndCopy() {
				this.select();
				if ( navigator.clipboard ) {
					navigator.clipboard.writeText( $( this ).val() );
					$.gritter.options.position = alertPosition;
					$.gritter.add( {
						  title      : ""
						, text       : copiedText
						, class_name : "gritter-success"
						, sticky     : false
					} );
				}
			}

		} );

	};

	$( ".apple-services-token-generator" ).appleServicesTokenGenerator();

} )( presideJQuery );