( function(){
	mapkit.init( {
		authorizationCallback : function( done ) {
			fetch( cfrequest.mapkit.tokenUrl )
				.then( res => res.text() )
				.then( done );
		}
	} );

	const map             = new mapkit.Map( cfrequest.mapkit.container, {} )
	    , annotationProps = [ "title", "subtitle", "color", "glyphText", "glyphColor", "glyphImage", "clusteringIdentifier", "animates", "selected" ]
	    , clusterProps    = [ "title", "subtitle", "color", "glyphText", "glyphColor", "clusteringIdentifier" ];

	const decorateFeature = {
		Point: function( item, geoJSON ) {
			for( const prop of annotationProps ) {
				if ( typeof geoJSON.properties[ prop ] !== "undefined" ) {
					item[ prop ] = geoJSON.properties[ prop ];
				} else if ( typeof cfrequest?.mapkit?.geoJson?.defaults?.feature[ prop ] !== "undefined" ) {
					item[ prop ] = cfrequest.mapkit.geoJson.defaults.feature[ prop ];
				}
			}
			item.data = geoJSON.properties || {};
		},
		Polygon: function( item, geoJSON ) {},
		LineString: function( item, geoJSON ) {}
	};
	const geoJSONDelegate = {
		itemForFeature: function( item, geoJSON ) {
			if ( decorateFeature[ geoJSON.geometry.type ] ) {
				decorateFeature[ geoJSON.geometry.type ]( item, geoJSON );
			}
			return item;
		},
		geoJSONDidComplete: function( itemCollection ) {
			map.annotationForCluster = function( clusterAnnotation ) {
				for( const prop of clusterProps ) {
					if ( typeof cfrequest?.mapkit?.geoJson?.cluster[ prop ] !== "undefined" ) {
						clusterAnnotation[ prop ] = cfrequest.mapkit.geoJson.cluster[ prop ];
					}
				}
			};
			map.showItems( itemCollection );
		},
		geoJSONDidError: function( err ) {
			console.error( err );
		}
	};

	mapkit.importGeoJSON( cfrequest.mapkit.geoJson.data, geoJSONDelegate );
} )();