component {

	property name="mapkitDefaults" inject="coldbox:setting:mapkit.defaults";

	private function index( event, rc, prc, args={} ) {
		if ( !Len( args?.latitudeField ) || !Len( args?.latitudeField ) ) {
			return translateResource( "formcontrols.mapkitLocationPicker:required.arguments" );
		}

		var mapkitData = {
			  defaultLatitude  = mapkitDefaults.defaultLatitude
			, defaultLongitude = mapkitDefaults.defaultLongitude
			, defaultDelta     = mapkitDefaults.defaultDelta
			, focusDelta       = mapkitDefaults.focusDelta
			, authToken        = mapkitToken()
			, authTokenUrl     = event.buildLink( linkTo="mapkit.getToken" )
			, alertPosition    = getSetting( "adminNotificationsPosition" )
			, errors           = {
				postcode = {
					  title       = translateResource( "formcontrols.mapkitLocationPicker:postcode.error.title" )
					, notSupplied = translateResource( "formcontrols.mapkitLocationPicker:postcode.error.not.supplied" )
					, notFound    = translateResource( "formcontrols.mapkitLocationPicker:postcode.error.not.found" )
					, unexpected  = translateResource( "formcontrols.mapkitLocationPicker:postcode.error.unexpected" )
				},
				address = {
					  title       = translateResource( "formcontrols.mapkitLocationPicker:address.error.title" )
					, notSupplied = translateResource( "formcontrols.mapkitLocationPicker:address.error.not.supplied" )
					, notFound    = translateResource( "formcontrols.mapkitLocationPicker:address.error.not.found" )
					, unexpected  = translateResource( "formcontrols.mapkitLocationPicker:address.error.unexpected" )
				}
			}
		};

		event.includeData( { mapkitData=mapkitData } )
			.include( "/js/admin/mapkitLocationPicker/" );

		return renderView( view="formcontrols/mapkitLocationPicker/index", args=args );
	}

}
