/**
 * @presideService
 * @singleton
 */
component {

// CONSTRUCTOR
	public any function init() {
		return this;
	}

	public date function addTimeSpanToDate( required timespan timespan, date date=Now() ) {
		var secsInDay = 86400; // 60 * 60 * 24
		return DateAdd( "s", Fix( secsInDay * arguments.timespan ), arguments.date );
	}

	public string function normalizeCoordinate( required any coord ) {
		var lat = "";
		var lng = "";

		if ( IsSimpleValue( arguments.coord ) && ListLen( arguments.coord ) == 2 ) {
			lat = Trim( ListFirst( arguments.coord ) );
			lng = Trim( ListLast( arguments.coord ) );
		}
		if ( IsArray( arguments.coord ) && ArrayLen( arguments.coord ) == 2 ) {
			lat = Trim( arguments.coord[ 1 ] );
			lng = Trim( arguments.coord[ 2 ] );
		}
		if ( IsStruct( arguments.coord ) ) {
			lat = arguments.coord?.latitude;
			lng = arguments.coord?.longitude;
		}

		if ( IsNumeric( lat ) && IsNumeric( lng ) ) {
			return "#lat#,#lng#";
		}

		return "";
	}

	public string function normalizeMultipleCoordinates( required array coords, string separator="|" ) {
		var normalized = [];
		for( var coord in arguments.coords ) {
			ArrayAppend( normalized, normalizeCoordinate( coord ) );
		}

		return ArrayToList( normalized, arguments.separator );
	}
}