/**
 * @presideService
 * @singleton
 */
component {

	property name="jwt"   inject="jwt@jwtcfml";
	property name="utils" inject="AppleServicesUtils";


// CONSTRUCTOR
	public any function init() {
		return this;
	}

	public string function getJwt( timespan expiresIn=CreateTimeSpan( 0, 0, 20, 0 ) ) {
		var settings  = $getPresideCategorySettings( "appleservices" );
		var expires   = utils.addTimeSpanToDate( arguments.expiresIn );
		var serviceId = settings.weatherkit_service_id ?: "";
		var headers   = {
			    kid = settings.key_id
			  , id  = "#settings.team_id#.#serviceId#"
		};
		var payload   = {
			  iss = settings.team_id
			, iat = Now()
			, exp = expires
			, sub = serviceId
		};

		return jwt.encode( payload=payload, key=settings.private_key, algorithm="ES256", headers=headers );
	}

}